/* jshint node: true */
var path = require('path')

module.exports = {
  context: path.join(__dirname),
  entry: './lib/index.js',

  output: {
    path: path.join(__dirname, 'dist'),
    filename: 'index.js',
    libraryTarget: 'umd',
    library: 'ReactTangleResult'
  },
  // This seems to break the npm build...
  // externals: {
  //   'react': 'var React',
  //   'react/addons': 'var React'
  // },

  module: {
    loaders: [
      {
        test: /(\.js)|(\.jsx)$/,
        exclude: /node_modules/,
        loader: 'babel-loader',
        query: {
          presets: ['es2015', 'es2016', 'react']
        }
      }, {
        test: /\.css$/,
        loader: 'style!css!'
      }
    ]
  }
}
